/* Uso della classe LinkedList<E> del package java.util  */ 

//import java.util.LinkedList;
//import java.util.Random;


import java.util.*;

public class RandomList<T extends Comparable<T>> {


  public static void main (String[ ] args) {
     new RandomList<Integer>().int_run();
     new RandomList<String>().string_run();	
  } // method main

public void int_run(){

     	// GENERAZIONE LISTA CASUALE	
     	final int SEED = 111; // seme della sequenza
     	// Random r = new Random (SEED);
     	Random r = new Random ();
     	LinkedList<Integer> randList = new LinkedList<Integer>( );
     	// Inserimento in randList di 10 interi casuali nel range 0...99:
     	for (int i = 0; i < 10; i++)
             randList.addFirst(r.nextInt(100)); 
	System.out.println("Lista casuale generata:");
	System.out.println(randList.toString());

	/**** TEST METODI DI BASE ****/
	System.out.println("Dopo un inserimento in coda:");	
	randList.addLast(r.nextInt(100));
        System.out.println(randList.toString());

        System.out.println("Cancellazione alla posizione 2:" );
        randList.remove(2);
        System.out.println(randList.toString());

	System.out.println("Dopo una cancellazione in testa:");	
	randList.removeFirst();
        System.out.println(randList.toString());

	System.out.println("Dopo una cancellazione in coda:");	
	randList.removeLast();
        System.out.println(randList.toString());

	int val=r.nextInt(100), cont=0;
	// cerca val nella lista
	LinkedList<Integer> l=randList;
	for (int i=0; i<l.size(); i++) {
	  if ((Integer)l.get(i).compareTo(val)<=0) cont++;
	} 
	System.out.println("Ci sono " + cont + " elementi nella lista <= di " + val + ".");
 
 } // method int_run


  public void string_run(){

     	/**** GENERAZIONE LISTA di stringhe ****/	
     	LinkedList<String> list = new LinkedList<String>( );
     	// Inserimento in list di stringhe:
	list.addFirst("Alessandra");
	list.addFirst("Giacomo");
	list.addFirst("Zoe");
	list.addFirst("Federico");
	list.addFirst("Barbara");

	// list.addFirst(2);  errore in fase di compilazione

	System.out.println("Lista casuale generata:");
	System.out.println(list.toString());

	/**** TEST METODI DI BASE ****/
	System.out.println("Dopo due inserimenti in coda:");	
	list.addLast("penultimo");
	list.add("ultimo");
        System.out.println(list.toString());

        System.out.println("Cancellazione alla posizione 2:" );
        list.remove(2);
        System.out.println(list.toString());

	System.out.println("Dopo una cancellazione in testa:");	
	list.removeFirst();
        System.out.println(list.toString());

	System.out.println("Dopo una cancellazione in coda:");	
	list.removeLast();
        System.out.println(list.toString());


	/*** uso iteratori ***/
	System.out.println("\nIteratore while:");  // iteratore 1
    	Iterator<String> itr = list.iterator();
    	while (itr.hasNext()){
      		System.out.println(itr.next());
    	}

	
	int cont=0;
	System.out.println("\nFor avanzato:");  // iteratore 2
	for (String word: list) { 
	   System.out.println(word);
	   cont++;
	}
	System.out.println("Ci sono " + cont + " stringhe nella lista.");

	cont=0; 
	String s = "Giovanna";
	for (int i=0; i<list.size(); i++) {
	  if (((String)s).compareTo(list.get(i))>=0) cont++;
	}
	System.out.println("Ci sono " + cont + " stringhe nella lista <= di " + s + ".");

        
 } // method string_run



} // class RandomList
